(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: options_types.mli,v 1.10 2014/07/16 21:46:59 fclement Exp $ *)

open Refinement_types;;

(** {6 Algorithm configuration} *)

type option_external_program_command = string list;;

type option_dimension = int;;

type option_dimension_management = dimension_management;;

type option_cutting_strategy =
  | Option_Best_in_a_family
  | Option_Overall_best
and option_number_of_cuts = int
and option_basic_cutting_family = basic_cutting_family
and option_basic_cutting_families = option_basic_cutting_family list
;;

type option_candidate_cuttings_selection_criterion_ratio = float
and option_candidate_cuttings_selection_criterion_maximum_number = int
;;

type option_minimum_gradient = float;;

type option_max_iteration = int
and option_min_best_scalar_indicator = float
and option_min_scalar_relative_error = float
;;

(** {6 Program configuration} *)

type option_out_formatter =
  | Option_Std_out
  | Option_Std_err
  | Option_Out_file of Ufilename.t
;;

type option_report_allocated_memory = bool;;

type option_incremental_mode = bool;;

type option_graphics_mode = graphics_mode;;

type option_graphics_window_min_width = int
and option_graphics_window_max_width = int
and option_graphics_window_min_height = int
and option_graphics_window_max_height = int
;;

type option_graphics_color_scale_name =
  | Gray
  | Cool
  | Hot
  | Jet
;;

type option_graphics_parameter_min = float
and option_graphics_parameter_max = float
;;

type option_graphics_gradient_amplitude = float;;
